## seetaface-tennis 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.7)
project(tennis)

# set tennis version
set(TS_VERSION "1.0.2")

set(TARGET "SHARED" CACHE STRING "STATIC or SHARED" FORCE)
add_definitions(-DBUILDING_TENNIS)

# global root dir
set(SOLUTION_DIR ${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DTS_SOLUTION_DIR="${SOLUTION_DIR}")
# add_definitions("-Wall -g") # add gcc option in FLAGS_GCC, not here!

add_definitions(-DTS_DISABLE_PARALLEL)
# dir for common cmake files
list(APPEND CMAKE_MODULE_PATH ${SOLUTION_DIR}/cmake)
list(APPEND CMAKE_PREFIX_PATH ${SOLUTION_DIR}/cmake)

# set library name for different architectures
set(HASWEILL_LIB_NAME ${PROJECT_NAME}_haswell)
set(SANDYBRIDGE_LIB_NAME ${PROJECT_NAME}_sandy_bridge)
set(PENTINUM_LIB_NAME ${PROJECT_NAME}_pentium)

#------------------------------------------------------------------------------#
# ============================= Options start ================================ #
#------------------------------------------------------------------------------#
# Install path
set(CMAKE_INSTALL_PREFIX ${CMAKE_CURRENT_SOURCE_DIR}/build
    CACHE STRING "set install prefix")

# Option for platform
set(PLATFORM "auto" CACHE STRING "auto, x86 or x64")
# Build type, configuration
set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Debug or Release")

# If build test cases
option(TS_BUILD_TEST "[Optional] Build test" OFF)
# If build tool cases
option(TS_BUILD_TOOLS "[Optional] Build tools" OFF)
# If build with OpenCV, must set on if TS_BUILD_TEST=ON
option(TS_USE_OPENCV "[Optional] Use OpenCV" OFF)
# If build with debug API, must set on if TS_BUILD_TEST=ON
option(TS_USE_DEBUG_API "[Optional] Use Debug API" OFF)

# if use other kernel files
set(TS_EXTRA_KERNELS "" CACHE STRING "List kernels, like: rknn,nnie. Empty for no extra.")

# if use 
option(TS_USE_CUDA "[Optional] Use CUDA" OFF)
option(TS_USE_CUBLAS "[Optional] Use CUBLAS" OFF)
set(TS_CUDA_ARCH "" CACHE STRING "List arch, like: 60,61,62. Empty for all arch.")

# Options of optimizations
option(TS_USE_CBLAS "[Optional] Use CBLAS" OFF) # [discarded]
option(TS_USE_OPENMP "[Optional] Use OpenMP" ON)
option(TS_USE_SIMD "[Optional] Use SIMD" ON)
option(TS_DYNAMIC_INSTRUCTION "[Optional] Dynamic support for different instruction sets" OFF)
option(TS_ON_HASWELL "[Optional] Use AVX and FMA" OFF)
option(TS_ON_SANDYBRIDGE "[Optional] Use AVX but not FMA" OFF)
option(TS_ON_PENTIUM "[Optional] Use SSE" OFF)
#option(TS_USE_AVX "[Optional] Use AVX" OFF)
#option(TS_USE_SSE "[Optional] Use SSE" OFF)
#option(TS_USE_FMA "[Optional] Use FMA" OFF)
option(TS_USE_NEON "[Optional] Use NEON" OFF)
option(TS_USE_FAST_MATH "[Optional] Use fast math (-ffast-math)" OFF)
option(TS_ON_ARM "[Optional] Target is arm" OFF)
# Special for armv7
option(TS_ON_ARMV7 "[Optional] Target is arm-v7a" OFF)

# Not change for now version
option(TS_USE_PROFILER "[Optional] Use Profiler" ON)
option(TS_USE_HOOK "[Optional] Use Hook" ON)

# Deprecated option, no use after all.
option(TS_USE_WINOGRAD "[Deprecated] Use Winograd" OFF)

# Hidden options (do not uncomment, it already defined later)
# None

#------------------------------------------------------------------------------#
# ============================= Options end ================================== #
#------------------------------------------------------------------------------#

if ("${CMAKE_BUILD_TYPE}" STREQUAL "")
    set(CONFIGURATION "Release")
else ()
    set(CONFIGURATION ${CMAKE_BUILD_TYPE})
endif ()

message(STATUS "== Target: ${TARGET}")
message(STATUS "== Platform: ${PLATFORM}")
message(STATUS "== Configuration: ${CONFIGURATION}")

# set common compiler flags
include(LOCAL_FLAGS)
include(LOCAL_ENV)
include(tools)

if (TS_USE_PROFILER)
    add_definitions(-DTS_USE_PROFILER)
endif()
if (TS_USE_HOOK)
    add_definitions(-DTS_USE_HOOK)
endif()

if (TS_USE_DEBUG_API)
    message(STATUS "[Important] Use debug API: [ON]")
    add_definitions(-DTS_USE_DEBUG_API)
else (TS_USE_DEBUG_API)
    message(STATUS "[Important] Use debug API: [OFF]")
endif()

# set winograd support
if (TS_USE_WINOGRAD)
    add_definitions(-DTS_USE_WINOGRAD)
    message(STATUS "[Optional] Use Winograd: [ON]")
else (TS_USE_WINOGRAD)
    message(STATUS "[Optional] Use Winograd: [OFF]")
endif()

# if target is target
if (TS_ON_ARM)
	add_definitions(-DTS_ON_ARM)
endif()
if (TS_ON_ARMV7)
    add_definitions(-DTS_ON_ARMV7)
endif()

install(CODE "MESSAGE(\"Installing into ${CMAKE_INSTALL_PREFIX}\")")

set(LOCAL_OUTPUT_DIR ${PROJECT_SOURCE_DIR})

if (LOCAL_OUTPUT_DIR)
    set(EXECUTABLE_OUTPUT_PATH ${LOCAL_OUTPUT_DIR}/${ENV_RUNTIME_DIR})
    set(LIBRARY_OUTPUT_PATH ${LOCAL_OUTPUT_DIR}/${ENV_LIBRARY_DIR})
endif ()

include_directories(${SOLUTION_DIR}/include)
include_directories(${SOLUTION_DIR}/src)

set(SOURCE_DIR ${SOLUTION_DIR})

set(TENNIS_MODULES
        api
        backend
        board
        compiler
        core
        encryption
        engine
        frontend
        global
        memory
        module
        runtime
        utils
        )
set(TENNIS_ARCHIVES common cpu) # in kernels and ops

#add_definitions(-DTS_USE_SSE)
# 4 types of archive
# blas
# Eigen
# Ordinary
# Ordinary with chipset result

set(third_libraries)

if (TS_USE_OPENCV)
    add_definitions(-DTS_USE_OPENCV)
    message(STATUS "[Optional] Use OpenCV: [ON]")

    find_package(OpenCV REQUIRED)
    message(STATUS "    OpenCV library status:")
    message(STATUS "        version: ${OpenCV_VERSION}")
    # message(STATUS "    libraries: ${OpenCV_LIBS}")
    message(STATUS "        include path: ${OpenCV_INCLUDE_DIRS}")

    include_directories(${OpenCV_INCLUDE_DIRS})
    list(APPEND third_libraries ${OpenCV_LIBS})
else ()
    message(STATUS "[Optional] Use OpenCV: [OFF]")
endif ()

if (TS_USE_OPENMP)
    add_definitions(-DTS_USE_OPENMP)
    message(STATUS "[Optional] Use OpenMP: [ON]")

    include(use_openmp)
    list(APPEND third_libraries ${OPENMP_LIBRARY})
else ()
    message(STATUS "[Optional] Use OpenMP: [OFF]")
endif ()

if (TS_USE_CUDA)
    find_package(CUDA REQUIRED)
    message(STATUS "[Optional] Use CUDA: [ON]; Found ${CUDA_VERSION}")
    list(APPEND TENNIS_ARCHIVES gpu)
    add_definitions(-DTS_USE_CUDA)

    include(use_cuda)

    set(TS_USE_CUBLAS ON)
else()
    message(STATUS "[Optional] Use CUDA: [OFF]")
endif()

if (WIN32)
    # list(APPEND third_libraries pthread)
elseif (APPLE)
    # list(APPEND third_libraries pthread)
    set(CMAKE_MACOSX_RPATH 1)
elseif (UNIX)
    list(APPEND third_libraries pthread)
    list(APPEND third_libraries m)
else ()
endif ()

if(TS_USE_CUBLAS)
	message(STATUS "[Optional] Use CUBLAS: [ON]")
	add_definitions(-DTS_USE_CUBLAS)
    list(APPEND third_libraries ${CUDA_CUBLAS_LIBRARIES})
else()
	message(STATUS "[Optional] Use CUBLAS: [OFF]")
endif()

if (TS_USE_CBLAS)
    message(STATUS "[Optional] Use CBLAS: [ON]")
    list(APPEND TENNIS_ARCHIVES cblas)
    add_definitions(-DTS_USE_CBLAS)

    include(use_cblas)
else()
    message(STATUS "[Optional] Use CBLAS: [OFF]")
endif()


if ("${TS_EXTRA_KERNELS}" STREQUAL "")
else()
    message(STATUS "[Important] Extra kernels: ${TS_EXTRA_KERNELS}")
    string(REPLACE "," ";" EXTRA_ARCHIVE_LIST ${TS_EXTRA_KERNELS})

    foreach (archive ${EXTRA_ARCHIVE_LIST})
        string(STRIP ${archive} archive)
        list(APPEND TENNIS_ARCHIVES ${archive})

        if (EXISTS ${SOLUTION_DIR}/cmake/use_${archive}.cmake)
            include(use_${archive})
        else ()
            message(AUTHOR_WARNING "Not found cmake/use_${archive}.cmake for ${archive}")
        endif ()
    endforeach ()
endif()


set(INCLUDE_FILES)
set(SRC_FILES)
set(SRC_INCLUDE_FILES)

foreach (module ${TENNIS_MODULES})
    FILE(GLOB_RECURSE INCLUDE_${module}_FILES ${SOURCE_DIR}/include/${module}/*.h)
    LIST(APPEND INCLUDE_FILES ${INCLUDE_${module}_FILES})

    FILE(GLOB_RECURSE SRC_${module}_FILES ${SOURCE_DIR}/src/${module}/*.cpp)
    LIST(APPEND SRC_FILES ${SRC_${module}_FILES})

    FILE(GLOB_RECURSE SRC_INCLUDE_${module}_FILES ${SOURCE_DIR}/src/${module}/*.h)
    LIST(APPEND SRC_INCLUDE_FILES ${SRC_INCLUDE_${module}_FILES})
endforeach ()

foreach (archive ${TENNIS_ARCHIVES})
    FILE(GLOB_RECURSE INCLUDE_ARCHIVE_${archive}_FILES
            ${SOURCE_DIR}/include/kernels/${archive}/*.h
            ${SOURCE_DIR}/include/ops/${archive}/*.h
            )
    LIST(APPEND INCLUDE_FILES ${INCLUDE_ARCHIVE_${archive}_FILES})

    FILE(GLOB_RECURSE SRC_ARCHIVE_${archive}_FILES
            ${SOURCE_DIR}/src/kernels/${archive}/*.cpp
            ${SOURCE_DIR}/src/ops/${archive}/*.cpp
            )
    LIST(APPEND SRC_FILES ${SRC_ARCHIVE_${archive}_FILES})

    if (TS_USE_CUDA)
        FILE(GLOB_RECURSE SRC_ARCHIVE_${archive}_CU_FILES
                ${SOURCE_DIR}/src/kernels/${archive}/*.cu
                ${SOURCE_DIR}/src/ops/${archive}/*.cu
                )
        LIST(APPEND SRC_FILES ${SRC_ARCHIVE_${archive}_CU_FILES})
    endif()

    FILE(GLOB_RECURSE SRC_INCLUDE_ARCHIVE_${archive}_FILES
            ${SOURCE_DIR}/src/kernels/${archive}/*.h
            ${SOURCE_DIR}/src/ops/${archive}/*.h
            )
    LIST(APPEND SRC_INCLUDE_FILES ${SRC_INCLUDE_ARCHIVE_${archive}_FILES})
endforeach ()

ts_add_library(${PROJECT_NAME}_LIB ${TARGET} ${INCLUDE_FILES} ${SRC_INCLUDE_FILES} ${SRC_FILES})
target_link_libraries(${PROJECT_NAME}_LIB ${third_libraries})
set_target_properties(${PROJECT_NAME}_LIB PROPERTIES OUTPUT_NAME ${PROJECT_NAME}${ENV_SUFFIX})

if (TS_USE_SIMD)
    message(STATUS "[Optional] Use SIMD: [ON]")
    add_definitions(-DTS_USE_SIMD)
    if (TS_ON_HASWELL)
        message(STATUS "[Optional] Use AVX and FMA: [ON]")
        target_compile_definitions(${PROJECT_NAME}_LIB PRIVATE TS_USE_AVX TS_USE_FMA)
        ts_add_instruction_support(${PROJECT_NAME}_LIB 0)
    elseif (TS_ON_SANDYBRIDGE)
        message(STATUS "[Optional] Use AVX: [ON]")
        target_compile_definitions(${PROJECT_NAME}_LIB PRIVATE TS_USE_AVX)
        ts_add_instruction_support(${PROJECT_NAME}_LIB 1)
    elseif (TS_ON_PENTIUM)
        message(STATUS "[Optional] Use SSE: [ON]")
        target_compile_definitions(${PROJECT_NAME}_LIB PRIVATE TS_USE_SSE)
        ts_add_instruction_support(${PROJECT_NAME}_LIB 2)
    elseif (TS_USE_NEON)
        message(STATUS "[Optional] Use NEON: [ON]")
        target_compile_definitions(${PROJECT_NAME}_LIB PRIVATE TS_USE_NEON)
    endif()
endif()

# support different instruction set
if(TS_DYNAMIC_INSTRUCTION)
    message(STATUS "[Optional] Dynamic support for different instruction sets: [ON]")

    ts_add_library(${HASWEILL_LIB_NAME}_LIB ${TARGET} ${INCLUDE_FILES} ${SRC_INCLUDE_FILES} ${SRC_FILES})
    target_link_libraries(${HASWEILL_LIB_NAME}_LIB ${third_libraries})
    target_compile_definitions(${HASWEILL_LIB_NAME}_LIB PRIVATE TS_USE_AVX TS_USE_FMA)
    ts_add_instruction_support(${HASWEILL_LIB_NAME}_LIB 0)

    ts_add_library(${SANDYBRIDGE_LIB_NAME}_LIB ${TARGET} ${INCLUDE_FILES} ${SRC_INCLUDE_FILES} ${SRC_FILES})
    target_link_libraries(${SANDYBRIDGE_LIB_NAME}_LIB ${third_libraries})
    target_compile_definitions(${SANDYBRIDGE_LIB_NAME}_LIB PRIVATE TS_USE_AVX)
    ts_add_instruction_support(${SANDYBRIDGE_LIB_NAME}_LIB 1)

    ts_add_library(${PENTINUM_LIB_NAME}_LIB ${TARGET} ${INCLUDE_FILES} ${SRC_INCLUDE_FILES} ${SRC_FILES})
    target_link_libraries(${PENTINUM_LIB_NAME}_LIB ${third_libraries})
    target_compile_definitions(${PENTINUM_LIB_NAME}_LIB PRIVATE TS_USE_SSE)
    ts_add_instruction_support(${PENTINUM_LIB_NAME}_LIB 2)

    set_target_properties(${HASWEILL_LIB_NAME}_LIB
                          PROPERTIES
                          OUTPUT_NAME ${HASWEILL_LIB_NAME}${ENV_SUFFIX})
    set_target_properties(${SANDYBRIDGE_LIB_NAME}_LIB
                          PROPERTIES
                          RUNTIME_OUTPUT_DIRECTORY ${LOCAL_OUTPUT_DIR}/${ENV_RUNTIME_DIR}
                          OUTPUT_NAME ${SANDYBRIDGE_LIB_NAME}${ENV_SUFFIX})
    set_target_properties(${PENTINUM_LIB_NAME}_LIB
                          PROPERTIES

=== debian/changelog ===
seetaface-tennis (1.0.0-1) unstable; urgency=medium

  * Initial release 

 -- liujianqing <liujianqiang@uniontech.com>  Fri, 03 Dec 2021 17:08:50 +0800

=== debian/control ===
Source: seetaface-tennis
Section: devel
Priority: optional
Maintainer: likier <likier@sina.cn>
Build-Depends: debhelper (>= 11),
 libopencv-dev,
 cmake,
 seetaface-open-role-zoo,
 seetaface-authorize
Standards-Version: 4.5.1
Homepage: https://github.com/TenniS-Open/TenniS.git
Rules-Requires-Root: no

Package: seetaface-tennis
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: tennis for seetaface
  TenniS: Tensor based Edge Neural Network Inference System

## seetaface-tennis 1.0.1

=== debian/changelog ===
seetaface-tennis (1.0.1-0deepin2) unstable; urgency=medium

  * fix: update debian build rules for sw64 architecture

 -- YeShanShan <yeshanshan@uniontech.com>  Wed, 16 Jul 2025 11:19:23 +0800

seetaface-tennis (1.0.1-0deepin1) unstable; urgency=medium
  
  [ LiChengGang ]
  * fix gcc-13 build error

 -- LiChengGang <lichenggang@uniontech.com>  Thu, 21 Dec 2023 14:40:26 +0800

seetaface-tennis (1.0.0-1+u001) UNRELEASED; urgency=medium

  * update

 -- likier <likier@sina.cn>  Thu, 28 Apr 2022 17:59:00 +0800

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


%:
	dh $@

ifeq ($(DEB_HOST_ARCH_CPU),sw64)
override_dh_auto_configure:
	dh_auto_configure -- -DTS_USE_OPENMP=OFF -DTS_USE_SIMD=OFF
endif

override_dh_auto_install:
	dh_auto_install -- prefix=/usr
